jQuery(document).ready(function ($) {

    //LOG TABLE DATATABLES
    var logList = $('#logList').DataTable({
        "processing": true,
        "serverSide": true,
        "columns": [//columns options
            {"orderable": true, "searchable": false, "width": "10%"},
            {"orderable": true, "searchable": false, "width": "15%"},
            {"orderable": true, "searchable": true, "width": "10%"},
            {"orderable": false, "searchable": true, "width": "30%"},
            {"orderable": true, "searchable": false, "width": "10%"},
            {"orderable": false, "searchable": false, "width": "10%"},
            {"orderable": false, "searchable": false, "width": "10%"}
        ],
        "pagingType": "full_numbers", //pagination
        "order": [[0, "desc"]],
        "ajax": {
            "url": ajaxurl,
            "type": "POST",
            "data": {'action': 'load_in8_logs'}
        },
        "createdRow": function ( row, data, index ) {
            if( $(row).find('.in8_error_list_class_main').length > 0 ){
                var $wrap = $(row).find('.in8_error_list_class_main');
                if( $wrap.find('li').length > 3 ){
                    $wrap.addClass('limit');
                }
            }
        }
    });
    //LOG TAB AJAX REFRESH TIME
    setInterval(ajaxcall, 60000); //recurring call at every 1 sec    

    //EMAIL TAB
    $(document).on('change', '.email_action_select', function () {
        if ($(this).val() == 1) {
            $(this).parent().next('.form-group').show();
        } else {
            $(this).parent().next('.form-group').hide();
        }
    });

    //EMAIL TAB
    $(document).on('click', '#addMoreEmailActions', function (e) {
        e.preventDefault();
        var clone = $(".in8_email_action:last").clone();
        $(this).parent().before(clone);
        var cloned = $(".in8_email_action:last");
        $(cloned).find('input').val('');
        $(cloned).find('.email_action_select').val(0);
        $(cloned).find('.ns-error-code').val(0);
        $(cloned).find('.defaultHide').hide();
    });
    //EMAIL TAB
    $(document).on('click', '.removeEmailActionRow', function (e) {
        e.preventDefault();
        $(this).parent().parent().remove();
    });

    $(document).on('change', '.ns-error-code', function (e) {
        var selected_val = $(this).val();
        var select_obj = this;
        $(".ns-error-code").not(this).each(function (i, obj) {
            if ($(obj).val() == selected_val) {
                e.preventDefault();
                $(select_obj).val(0);
                alert("Email action already defined for " + selected_val);
            }
        });
    });

    $("#emailActionsSave").on('click', function (e) {
        if ($(".ns-error-code").length === 0) {
            return false;
        }
        $(".ns-error-code").each(function (i, obj) {
            if ($(obj).val() === 0) {
                e.preventDefault();
                alert("Please select valid email actions");
                return false;
            }
        });
    });
    $("#in8_setting_import").on('submit', function (e) {
        e.preventDefault();
        var formData = new FormData($(this)[0]);
        formData.append("action", "import_in8_settings");
        $.ajax({
            url: ajaxurl,
            type: "POST",
            data: formData,
            datatype: "json",
            contentType: false,
            async: false,
            cache: false,
            processData: false
        }).error(function (xhr, status, error) {
            alert(error);
        }).success(function (data, status, xhr) {
            data = JSON.parse(data);
            alert(data.message);
            if (data.status == 1) {
                location.reload();
            }
        });
        return false;
    });

    $('#logList').on('click', '.in8_error_list_class_main.limit', function(){
        $(this).removeClass('limit');
    })
});

//AJAX FROM UPDATING CURRENT TIME FROM SERVER
function ajaxcall() {
    jQuery.ajax({
        url: ajaxurl,
        data: {'action': 'get_server_time'},
        success: function (data) {
            jQuery('#current_time').html(data);
        }
    });
}