<?php

    //export the options into a json
    add_action('init', 'exportSettings');

    function exportSettings() {
        if (!isset($_GET['export_all_in8_settings'])) {
            return FALSE;
        }
        //data to export
        $exported_options = [];
        // loop over all options to export
        foreach (IN8_Settings::$exportable_options as $export_option_key => $export_option_name) {
            $options = get_option($export_option_key, []); //get option data
            if (!empty($options)) {
                $exported_options[$export_option_key] = $options; //fill option data to main array
            }
        }

        if (!empty($exported_options)) {
            $export_filename = 'in8_setting_options.json';
            //download json of settings
            header('Content-disposition: attachment; filename=' . $export_filename);
            header('Content-type: application/json');
            echo json_encode($exported_options);
            exit();
        }
    }

    //ajax for saving plugin admin settings
    add_action('wp_ajax_import_in8_settings', 'importSettings');

    function importSettings() {

        $return = [];
        $return['status'] = 0;
        $import_file = $_FILES['import_file']['tmp_name'];

        if (empty($import_file)) {
            $return['message'] = 'Please upload a file to import';
        }

        //load settings from uploaded file
        $settings = (array) json_decode(file_get_contents($import_file), 1);

        if (!empty($settings)) {
            $imported_settings = [];
            foreach ($settings as $option_key => $option_val) {
                if (array_key_exists($option_key, IN8_Settings::$exportable_options)) { //check if a valid option
                    update_option($option_key, $option_val);
                    $imported_settings[] = IN8_Settings::$exportable_options[$option_key];
                }
            }

            $return['message'] = 'Settings imported succesfully';
            $return['status'] = 1;
        } else {
            $return['message'] = 'Please upload a valid file to import. This file seems to invalid.';
        }

        echo json_encode($return);
        exit;
    }
    